//##################################################################################################
//
//  Ceetron 3D Components
//  Platform integration for Qt
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2015, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeVisualization/ViewerUIFramework.h"
#include "CeeVisualization/View.h"
#include "CeeCore/PtrRef.h"
#include "CeeCore/LogManager.h"

#include <QOpenGLWidget>

namespace cee {
namespace qt {



//==================================================================================================
//
// 
//
//==================================================================================================
class ViewerOpenGLWidget : public QOpenGLWidget, public vis::ViewerUIFramework
{
public:
    ViewerOpenGLWidget(vis::OpenGLContextGroup* contextGroup, QWidget* parent);
    virtual ~ViewerOpenGLWidget();

    void            setView(vis::View* aView);
    vis::View*      view();

    void            logOpenGLInfo();

protected:
    virtual void    initializeGL();
    virtual void    resizeGL(int width, int height);
    virtual void    paintGL();

private:
    virtual void    onViewerOpenGLReady();

private:
    virtual void            doRequestRedraw();
    virtual void            doRequestImmediateRedraw();
    virtual bool            doMakeCurrent();
    virtual bool            doIsCurrent();
    virtual unsigned int    doGetDefaultFramebufferObject();

    void                    qtOpenGLContextAboutToBeDestroyed();

private:
    bool                    m_viewerHasBeenInitialized;
    PtrRef<vis::View>       m_view;
};


}
}
