//##################################################################################################
//
//  Ceetron 3D Components
//  Component: Core
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

//
//  W A R N I N G
//  -------------
//
// This file is not part of Ceetron 3D Components.  It exists purely as an implementation detail.  
// This header file may change from version to version without notice, or even be removed.
//

#pragma once

#ifdef WIN32
#if (_MSC_VER < 1910)
#pragma warning (disable: 4800)
#endif
#endif

// Also brings in assert

#include "CeeCore/Str.h"
#include "CeeCore/RefCountedObject.h"
#include <iostream>
#include <stdexcept>

namespace cee
{

class CEE_CORE_EXPORT AssertManager : public RefCountedObject
{

public:

    static void setParamAssertThrowsException(bool throws);
    static bool paramAssertThrowsException();
    static void throwParamAssertException(void* pointer, const char* fileName, int lineNumber, const char* expression, const char* message);
    static void handleParamAssert(const void* pointer, const char* fileName, int lineNumber, const char* expression, const char* message);
    static void throwParamAssertException(bool test, const char* fileName, int lineNumber, const char* expression, const char* message);

private:
    AssertManager();
    static bool setGetParamAssertThrowsException(bool throws, bool set);
    friend class CoreComponent;

};
}

