//##################################################################################################
//
//  Ceetron 3D Components
//  Component: Core
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2014, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeCore/Base.h"
#include "CeeCore/Instance.h"
#include "CeeCore/PtrRef.h"

#include <string>

namespace cee {

class PropertySet;
class AssertManager;

//==================================================================================================
//
// Static class for Core component
//
//==================================================================================================
class CEE_CORE_EXPORT CoreComponent
{
public:
    static PtrRef<Instance> initialize(unsigned int licenseKeyA = 0, unsigned int licenseKeyB = 0);

    static unsigned int     version();
    static Str              versionString();
    static void             logVersionInfo();

    static LogManager*      logManager();
    static AssertManager*   assertManager();

public:
    static void             internal_configureComponent(const PropertySet& internalConfiguration);

private:
    CoreComponent();
    CEE_DISALLOW_COPY_AND_ASSIGN(CoreComponent);
};

}  
