//##################################################################################################
//
//  Ceetron 3D Components
//  Component: Core
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

// Needed for std::auto_ptr
#include <memory>

#ifdef WIN32

// Disable 4251, only used in private: so it is not accessible for users of the DLL
#define CEE_PRIVATE_IMPL(Class) \
__pragma(warning (push)) \
__pragma(warning (disable: 4251)) \
std::auto_ptr<class Class##Private> m_pimpl; \
__pragma(warning (pop))

#else

#define CEE_PRIVATE_IMPL(Class) \
std::auto_ptr<class Class##Private> m_pimpl

#endif

#define CEE_BASE_F(Class) \
friend class Class

#define CEE_PRIVATE_F(Class) \
friend class Class##Private

#define CEE_PRIVATE_INIT(Class) \
m_pimpl = std::auto_ptr<Class##Private>(new Class##Private)

#define CEE_PRIVATE_INIT_PARAM1(Class, ConstrutorParam1) \
m_pimpl = std::auto_ptr<Class##Private>(new Class##Private(ConstrutorParam1))

#define CEE_PRIVATE_INIT_PARAM2(Class, ConstrutorParam1, ConstrutorParam2) \
m_pimpl = std::auto_ptr<Class##Private>(new Class##Private(ConstrutorParam1, ConstrutorParam2))

#define CEE_PRIVATE_INIT_PARAM3(Class, ConstrutorParam1, ConstrutorParam2, ConstrutorParam3) \
m_pimpl = std::auto_ptr<Class##Private>(new Class##Private(ConstrutorParam1, ConstrutorParam2, ConstrutorParam3))

#define CEE_PRIVATE_INIT_PARAM4(Class, ConstrutorParam1, ConstrutorParam2, ConstrutorParam3, ConstrutorParam4) \
m_pimpl = std::auto_ptr<Class##Private>(new Class##Private(ConstrutorParam1, ConstrutorParam2, ConstrutorParam3, ConstrutorParam4))
