//##################################################################################################
//
//  Ceetron Export
//  Component: VTFx
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2015, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeVTFx/Base.h"
#include "CeeVTFx/Block.h"

#include "CeeCore/RefCountedObject.h"
#include "CeeCore/Str.h"
#include "CeeCore/PtrRef.h"

namespace cee {
namespace vtfx {

class File;

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_VTFX_EXPORT Database : public RefCountedObject
{
public:
    Database(File* file, const Str& databaseName, int databaseId);
    virtual ~Database();

    int             id() const;
    Str             name() const;

    bool            writeBlock(const Block* block);

    size_t          blockCount(Block::BlockType blockType) const;
    PtrRef<Block>   blockByIndex(Block::BlockType blockType, size_t blockIndex);
    PtrRef<Block>   blockById(Block::BlockType blockType, int blockId);

private:
    Database(File* file, int databaseId); 
    bool            internal_parse();

private:
    friend class FilePrivate; 
    friend class File; 
    
    CEE_PRIVATE_IMPL(Database);
    CEE_DISALLOW_COPY_AND_ASSIGN(Database);
};

}
}
